.image_builder:
  extends:
  - .docker
  stage: prepare
  image: docker:${DOCKER_VERSION}-git
  script:
  - apk add --no-cache curl
  - source ./ci/build_ci_image

prepare ci image:
  extends:
  - .image_builder
  - .linux-dependency-checksums
  - .rules:prepare:ci:image:merge-requests
  variables:
    BUILD_IMAGE: $CI_IMAGE
    BUILD_DOCKERFILE: ./dockerfiles/ci/Dockerfile
    PWSH_VERSION: "7.3.4-1"

prepare alpine-no-root image:
  extends:
  - .image_builder
  - .rules:prepare:alpine-no-root:image:merge-requests
  variables:
    BUILD_IMAGE: registry.gitlab.com/gitlab-org/gitlab-runner/alpine-no-root:latest
    BUILD_DOCKERFILE: ./tests/dockerfiles/alpine-no-root/Dockerfile

prepare alpine-entrypoint image:
  extends:
  - .image_builder
  - .rules:prepare:alpine-entrypoint:image:merge-requests
  variables:
    BUILD_IMAGE: registry.gitlab.com/gitlab-org/gitlab-runner/alpine-entrypoint:latest
    BUILD_DOCKERFILE: ./tests/dockerfiles/alpine-entrypoint/Dockerfile

prepare alpine-entrypoint-stderr image:
  extends:
  - .image_builder
  - .rules:prepare:alpine-entrypoint:image:merge-requests
  variables:
    BUILD_IMAGE: registry.gitlab.com/gitlab-org/gitlab-runner/alpine-entrypoint-stderr:latest
    BUILD_DOCKERFILE: ./tests/dockerfiles/alpine-entrypoint/Dockerfile.stderr

prepare alpine-id-overflow image:
  extends:
  - .image_builder
  - .rules:prepare:alpine-id-overflow:image:merge-requests
  variables:
    BUILD_IMAGE: registry.gitlab.com/gitlab-org/gitlab-runner/alpine-id-overflow:latest
    BUILD_DOCKERFILE: ./tests/dockerfiles/alpine-id-overflow/Dockerfile

prepare helper-entrypoint image:
  extends:
  - .docker
  - .rules:prepare:gitlab-runner-helper-entrypoint:image:merge-requests
  stage: prepare
  variables:
    BUILD_DOCKERFILE_BASEDIR: ./tests/dockerfiles/gitlab-runner-helper-entrypoint
    BUILD_IMAGE: registry.gitlab.com/gitlab-org/gitlab-runner/helper-entrypoint:latest
    BUILD_DOCKERFILE: "$BUILD_DOCKERFILE_BASEDIR/dockerfile"
  script:
  - make helper-bin-host
  - mkdir -p "$BUILD_DOCKERFILE_BASEDIR/binaries/"
  - cp out/binaries/gitlab-runner-helper/gitlab-runner-helper.x86_64 "$BUILD_DOCKERFILE_BASEDIR/binaries/gitlab-runner-helper"
  - source ./ci/build_ci_image

prepare go fips:
  extends:
    - .docker
    - .rules:prepare:go-fips:image:merge-requests
  stage: prepare
  image: docker:${DOCKER_VERSION}-git
  needs:
    - prepare ubi base
  variables:
    BUILD_IMAGE: $GO_FIPS_IMAGE
    GO_VERSION: $GO_FIPS_VERSION
  script:
    - apk add --no-cache curl make bash
    - make go-fips-docker

prepare ubi base:
  extends:
    - .docker
    - .rules:prepare:go-fips:image:merge-requests
  stage: prepare
  image: docker:${DOCKER_VERSION}-git
  script:
    - apk add --no-cache curl make bash
    - make ubi-fips-base-docker

prepare runner-incept variables:
  stage: prepare
  extends:
    - .rules:merge_request_pipelines:no_docs:only_canonical
  script:
    - echo "UPSTREAM_CI_COMMIT_REF=$(./ci/upstream_commit_ref)" >> incept.env
  after_script:
    - cat incept.env
  artifacts:
    reports:
      dotenv: incept.env

test ci scripts:
  stage: prepare
  extends:
    - .rules:prepare:test-ci-scripts:merge-requests
  needs:
    - job: "prepare ci image"
      optional: true
  script:
    - make test_go_scripts
